
package
{

  import flash.utils.ByteArray;
  import flash.utils.Dictionary;
  import flash.utils.Endian;

  public class xTmxLoad
  {
	  public var mapName:String = "0"; //needed(?)
	
	  public var mwidth:int = 0;
	  public var mheight:int = 0;
	  public var cw:Number = 0;
	  public var ch:Number = 0;
	
    public var worldWidth:int = 0;
    public var worldHeight:int = 0;
    
	  public var tileName:String = "0"; //tileset name
	
	
	  public var dictMap:Dictionary; //dict -- Vector.<int>
	  public var vecMap:Vector.<Vector.<int>>; //in case you dont want to refer them by name and just need them all
	
	  public var dictAct:Dictionary;
	  public var vecAct:Vector.<xTmxAct>;
	
	  //todo -- load map properties or something
	
	
	  public function getMap(wname:String):Vector.<int>	{ return dictMap[wname]; }
	
	  public function getAct(wname:String):xTmxAct { return dictAct[wname]; }
	
    //mirror vertically the position of all actors
    public function mirrorVertAllActor():void
    {
      var i:int;
      var a:xTmxAct;
      var num:int;
      var worldh:Number;
      
      worldh = ch * mheight;
      
      num = vecAct.length;
      for (i = 0; i < num; i++)
      {
        a = vecAct[i];
        a.cy = worldh - a.cy; 
        
      }//nexti
      
    }//mirvertactor
    
    
	
	  //actors -- its public, just go through them manually, whatever
	
	  public function loadMap(embed:Class):void
	  {
		  var xm:XML;
		  var w:XML;
          var o:XML;
		  var k:XML;
		  var m:Vector.<int>;
		  var a:xTmxAct;
		  var i:int;
		  var num:int;
		  var t:int;
		
		  dictMap = new Dictionary();
		  vecMap = new Vector.< Vector.<int> >(0, false);
		  dictAct = new Dictionary();
		  vecAct = new Vector.<xTmxAct>(0, false);
		
		  xm = new XML(new embed);
		
		
		  mwidth = xm.@width;
		  mheight = xm.@height;
		  cw = xm.@tilewidth;
		  ch = xm.@tileheight;

        worldWidth = cw * mwidth;
        worldHeight = ch * mheight;

      
		  num = mwidth * mheight;
		
		  w = xm.tileset[0];	
		
		  //if the tileset is just an image then take out the filename (.png etc) if its using a tsx no need to do that
		  tileName = w.@source;
		  if (tileName != "") { tileName = tileName.substr(0, tileName.length - 4); }
		  else { tileName = w.@name; }
	
		  var wname:String;
		  var ba:ByteArray;
		  var mname:String;
			
		  //load layers
		  for each (w in xm.*)
		  {	
			  wname = w.name(); wname = wname.toLowerCase();
			   if (wname != "layer") { continue; }
			   
			   mname = w.@name; mname = mname.toLowerCase();
			   
			   
		  //	 trace("layer ", mname);
			
			   ba = base64ToByteArray(w.data.*); 
			   ba.uncompress();
			   
			   ba.position = 0;
			   ba.endian = Endian.LITTLE_ENDIAN;
			   
			   //tmx format needs 'special' conversion
			   m = new Vector.<int>(num, false);
			   for (i = 0; i < num; i++)
			   {
				   t = ba.readUnsignedInt() - 1;
				   if (t < 0) { t = 0; }
				   m[i] = t;
				   
			   }//nexti
			   
			   dictMap[mname] = m;
			   vecMap.push(m);
		  }//nextw

		  var wid:int;
		
		  wid = 0;
		
	      for each(w in xm.*)
          {
            wname = w.name(); wname = wname.toLowerCase();
		    
		     if (wname != "objectgroup") { continue;  }
					
		         for each(o in w.*)
                 {
			             wid += 1;
			             
			             a = new xTmxAct();
			             a.ax = o.@x;
			             a.ay = o.@y;
			             a.aw = o.@width;
			             a.ah = o.@height;
			             a.cx = a.ax + a.aw * 0.5;
			             a.cy = a.ay + a.ah * 0.5;
			             
			             a.wtype = ("" + o.@type).toLowerCase();
			             a.wname = o.@name;
			             
			          //   trace("actor ", a.wname, a.type);
			             
			             vecAct.push(a);
			             dictAct[a.wname] = a;
			             
			             if (o.properties[0] == null) { continue; }
			             
			             a.dictProp = new Dictionary();
			             
			           //  for each (k in o.properties[0].property[0])  { a.dictProp[k.@name] = k.@value; trace("prop ", k.@name, k.@value);   }
			                for each (k in o.properties[0].property[0])  { a.dictProp[k.@name] = k.@value;   }
			
		             }//nexto
		        }//nextw

            
	  }//loadmap
	
	
		  //source
		  //http://pixelpracht.wordpress.com/2010/03/31/flash-tmx-parser/
		  private static const BASE64_CHARS:String = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
		
		  protected function base64ToByteArray(data:String):ByteArray 
		  {
			  var output:ByteArray = new ByteArray();
			  //initialize lookup table
			  var lookup:Array = [];
			  for(var c:int = 0; c < BASE64_CHARS.length; c++)
				  lookup[BASE64_CHARS.charCodeAt(c)] = c;

			  var outputBuffer:Array = new Array(3);
			
			  for (var i:uint = 0; i < data.length - 3; i += 4) 
			  {
				  //read 4 bytes and look them up in the table
				  var a0:int = lookup[data.charCodeAt(i)];
				  var a1:int = lookup[data.charCodeAt(i + 1)];
				  var a2:int = lookup[data.charCodeAt(i + 2)];
				  var a3:int = lookup[data.charCodeAt(i + 3)];
			
				  // convert to and write 3 bytes
				  if(a1 < 64)
					  output.writeByte((a0 << 2) + ((a1 & 0x30) >> 4));
				  if(a2 < 64)
					  output.writeByte(((a1 & 0x0f) << 4) + ((a2 & 0x3c) >> 2));
				  if(a3 < 64)
					  output.writeByte(((a2 & 0x03) << 6) + a3);
			  }
			
			  // Rewind & return decoded data
			  output.position = 0;
			  return output;
		  }//base64toba
		
  }//classend

}
